;;;; -*- Mode: Lisp -*-
;;;; $Id: usocket-allegro.lisp 449 2008-09-04 13:16:39Z binghe $

(in-package :usocket)

(defun socket-connect/udp (host port &key (stream nil) (element-type '(unsigned-byte 8))
			                  local-host local-port)
  (let ((socket
	 (if (and host port)
	     (socket:make-socket :type :datagram
				 :address-family :internet
				 :connect :active
				 :remote-host host
				 :remote-port port
				 :local-host local-host
				 :local-port local-port
				 :format (to-format element-type))
	     (socket:make-socket :type :datagram
				 :address-family :internet
				 :local-host local-host
				 :local-port local-port
				 :format (to-format element-type)))))
    (make-datagram-socket socket)))

(defmethod socket-send ((socket datagram-usocket) buffer length &key address port)
  (let ((s (socket socket)))
    (socket:send-to s buffer length :remote-host address :remote-port port)))

(defmethod socket-receive ((socket datagram-usocket) buffer length)
  (let ((s (socket socket)))
    (socket:receive-from s length :buffer buffer :extract t)))
