;;;; -*- Mode: Lisp -*-
;;;; $Id: usocket-lispworks.lisp 449 2008-09-04 13:16:39Z binghe $

(in-package :usocket)

(defun socket-connect/udp (host port &key (stream nil) (element-type 'base-char)
			                  (errorp t) local-host local-port)
  (if (and host port)
    (if stream
      (let ((stream (comm:open-udp-stream host port
                                          :element-type element-type
                                          :errorp errorp
					  :local-address local-host
					  :local-port local-port)))
        (make-stream-datagram-socket
         (comm:socket-stream-socket stream) stream))
      (make-datagram-socket (comm:connect-to-udp-server host port
							:errorp errorp
							:local-address local-host
							:local-port local-port)
			    :connected-p t))
    (make-datagram-socket (comm:open-udp-socket :errorp errorp
						:local-address local-host
						:local-port local-port)
			  :connected-p nil)))

(defmethod socket-send ((socket datagram-usocket) buffer length &key address port)
  (let ((s (socket socket)))
    (comm:send-message s buffer length address port)))

(defmethod socket-receive ((socket datagram-usocket) buffer length)
  (let ((s (socket socket)))
    (comm:receive-message s buffer length)))
