;;;; -*- Mode: Lisp -*-
;;;; $Id: usocket-sbcl.lisp 449 2008-09-04 13:16:39Z binghe $

(in-package :usocket)

(defun socket-connect/udp (host port &key (stream nil) (element-type '(unsigned-byte 8))
			                  local-host local-port)
  (let ((socket (make-instance 'sb-bsd-sockets:inet-socket
			       :type :datagram :protocol :udp)))
    (when (and local-host local-port)
      (sb-bsd-sockets:socket-bind socket
				  (host-to-vector-quad local-host)
				  local-port))
    (if (and host port)
	(progn
	  (sb-bsd-sockets:socket-connect socket (host-to-hbo host) port)
	  (if stream
	      (let ((stream (sb-bsd-sockets:socket-make-stream socket
							       :input t :output t
							       :buffering :full
							       :element-type element-type)))
		(make-stream-datagram-socket socket stream))
	      (make-datagram-socket socket)))
	(make-datagram-socket socket))))

(defmethod socket-send ((socket datagram-usocket) buffer length &key address port)
  (let* ((s (socket socket))
         (dest (if (and address port) (list (host-to-vector-quad address) port) nil)))
    (sb-bsd-sockets:socket-send s buffer length :address dest)))

(defmethod socket-receive ((socket datagram-usocket) buffer length
			   &key (element-type '(unsigned-byte 8)))
  (let ((s (socket socket)))
    (sb-bsd-sockets:socket-receive s buffer length :element-type element-type)))
